package com.example.tingyun_flutter_plugin;

import android.annotation.TargetApi;
import android.os.Build;
import android.text.TextUtils;
import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

import java.util.HashMap;
import java.util.Map;

/** TingyunFlutterPlugin */
public class TingyunFlutterPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "tingyun_flutter_plugin/newlens");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("getAutoStartConfiguration")) {
//      Map<String, Boolean> configuration = new HashMap<>();
//      configuration.put("autoStart", true);
//      configuration.put("logLevel", true);
//      configuration.put("webRequest", true);
//      configuration.put("crashReporting", true);

      Map<String, Boolean> configuration =
              com.networkbench.agent.impl.NBSAppAgent.getSwitchConfig();
//      configuration.put("logLevel", false);


//      config.put("enabled", NBSGlobalSettings.getInstance().isEnabled());
//      config.put("crashReporting", NBSGlobalSettings.getInstance().isCrash_enabled());
//      config.put("webRequest", NBSGlobalSettings.getInstance().isHttp_network_enabled());
//      config.put("action", NBSGlobalSettings.getInstance().isUIEnable());

      result.success(configuration);
    } else if(call.method.equals("reportCrash")){
//      android.util.Log.i("flutter", "reportCrash onMethodCall errorValue:" + call.argument("errorValue") +
//              ", reason:" + call.argument("reason") +
//              ", stacktrace:" + call.argument("stacktrace")
//              + ", platform:" + call.argument("platform"));
//
////      reportErrorFlutter(String message, Map<String, Object> metaData,
////              String errorStackTrace, int type)
//      com.networkbench.agent.impl.NBSAppAgent.reportErrorFlutter((String)call.argument("reason"),
//              null, (String)call.argument("stacktrace"), (int) call.argument("type"));
    }else if(call.method.equals("reportError")){
//      android.util.Log.i("flutter", "reportError onMethodCall errorValue:" + call.argument("errorValue") +
//              ", reason:" + call.argument("reason") +
//              ", stacktrace:" + call.argument("stacktrace")
//              + ", platform:" + call.argument("platform"));
      com.networkbench.agent.impl.NBSAppAgent.reportErrorFlutter((String)call.argument("reason"),
              (Map<String, Object>) (call.argument("props")), (String)call.argument("stacktrace"), (int) call.argument("type"));
    } else if(call.method.equals("reportDone")){
//      android.util.Log.i("flutter", "reportDone onMethodCall url:"
//              + call.argument("url") +
//              ", responseCode:" + call.argument("responseCode") +
//              ", error:" + call.argument("error")
//              + ", exception:" + call.argument("exception")
//              +", startTime:" + call.argument("startTime")
//              +", endTime:" + call.argument("endTime")
//              +", dnsTime:" + call.argument("dns")
//              +", ip:" + call.argument("ip")
//      );
//
//      Map<String, Object> infos = new HashMap<>();
//      infos.put("url", (String)call.argument("url"));
//      infos.put("responseCode", (int)call.argument("responseCode"));
//      infos.put("startTime", (long)call.argument("startTime"));
//      infos.put("endTime", (long) call.argument("endTime"));
//      infos.put("dns", (int) call.argument("dns"));
//      infos.put("ip", (String)call.argument("ip"));

//      com.networkbench.agent.impl.NBSAppAgent.reportNetwork(infos);

    } else if(call.method.equals("enterAction")){
//      android.util.Log.i("flutter", "enterAction name:"
//              + call.argument("name") +
//              ", key:" + call.argument("key")
//              +"， tag：" + call.argument("tag")
//      );

      int type = 0;
      if (call.argument("type") != null) {
        type = (int)call.argument("type");
      }
//      public static void enterAction(String actionName, int key, String enterJsStamp)
      com.networkbench.agent.impl.NBSAppAgent.enterActionFlutter((String)call.argument("name"), (int)call.argument("key"), (String)call.argument("enterTime"));
    } else if(call.method.equals("leaveAction")){
//      android.util.Log.i("flutter", "leaveAction:"
//              +"， key:" + call.argument("key")
//               +"， actionName：" + call.argument("actionName")
//                      +"， tag：" + call.argument("tag")
//                      +"， props：" + call.argument("props")
//              );
      int type = (int)call.argument("type");
      if(type == 1){
        com.networkbench.agent.impl.NBSAppAgent.leaveActionFlutterPage((int) call.argument("key"),
                (String) call.argument("leaveTime"), (String)call.argument("tag"),
                (Map<String, Object>) (call.argument("props")));
      } else {
        com.networkbench.agent.impl.NBSAppAgent.leaveAction((int) call.argument("key"),
                (String) call.argument("leaveTime"), (String)call.argument("tag"),
                (Map<String, Object>) (call.argument("props")));
      }
    } else if(call.method.equals("setUserIdentifier")){
      com.networkbench.agent.impl.NBSAppAgent.setUserIdentifier((String)call.argument("user"));
    }else if(call.method.equals("leaveBreadcrumb")){
      com.networkbench.agent.impl.NBSAppAgent.leaveBreadcrumb((String)call.argument("breadCrumb"));
    }else if(call.method.equals("setUserCrashMessage")){
      com.networkbench.agent.impl.NBSAppAgent.setUserCrashMessage(
              (String)call.argument("key"), (String)call.argument("value"));
    }else if(call.method.equals("onEvent")){
      com.networkbench.agent.impl.NBSAppAgent.onEvent((String)call.argument("eventId"),
              (String)call.argument("tag"), (Map<String, Object>) (call.argument("props")));
    } else if(call.method.equals("getRequestTagForInterceptor")){
      //取得跨引用的header
      String crossHeader = com.networkbench.agent.impl.NBSAppAgent.getCrossProcessHeaderValue();
      if(crossHeader == null)
        crossHeader = "";

      String uuid = java.util.UUID.randomUUID().toString();

      Map<String, String> requestInfos = new HashMap<>();
      requestInfos.put("crossHeader", crossHeader);
      requestInfos.put("uuid", uuid);

      result.success(requestInfos);
    } else if(call.method.equals("startWebRequestTiming")){
//      "requestTag": _requestTag,
//              "url": _url,
//              "startTime": this._networkBeginTime,
      Map<String, Object> infos = new HashMap<>();
      infos.put("requestTag", (String)call.argument("requestTag"));
      infos.put("url", (String)call.argument("url"));
      infos.put("startTime", (long) call.argument("startTime"));

      com.networkbench.agent.impl.NBSAppAgent.startWebRequestTiming(infos);
    } else if(call.method.equals("stopWebRequestTiming")){
      Map<String, Object> infos = new HashMap<>();
      infos.put("requestTag", (String)call.argument("requestTag"));
      infos.put("responseCode", (int)call.argument("responseCode"));
//      infos.put("responseMessage", (String)call.argument("responseMessage"));
      infos.put("endTime", (long) call.argument("endTime"));
      infos.put("dns", (int) call.argument("dns"));
      infos.put("ip", (String)call.argument("ip"));
//
      com.networkbench.agent.impl.NBSAppAgent.stopWebRequestTiming(infos);

    } else if(call.method.equals("getRequestTag")){
      String uuid = java.util.UUID.randomUUID().toString();
      result.success(uuid);
    } else if(call.method.equals("setCustomOnResumeEndIns")){
      com.networkbench.agent.impl.NBSAppAgent.setCustomOnResumeEndIns((String)call.argument("className"));
    }
    else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
