#import "TingyunFlutterPlugin.h"
#import <tingyunApp/NBSAppAgent.h>
//#import "NBSAppAgent.h"
//#if __has_include(<tingyun_flutter_plugin/tingyun_flutter_plugin-Swift.h>)
//#import <tingyun_flutter_plugin/tingyun_flutter_plugin-Swift.h>
//#else
//// Support project import fallback if the generated compatibility header
//// is not copied when this plugin is created as a library.
//// https://forums.swift.org/t/swift-static-libraries-dont-copy-generated-objective-c-header/19816
//#import "tingyun_flutter_plugin-Swift.h"
//#endif

@implementation TingyunFlutterPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {

    TingyunFlutterPlugin* instance = [[TingyunFlutterPlugin alloc] init];
    FlutterMethodChannel* channel =
        [FlutterMethodChannel methodChannelWithName:@"tingyun_flutter_plugin/newlens"
                                        binaryMessenger:[registrar messenger]];

        [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if ([@"getAutoStartConfiguration" isEqualToString:call.method]) {
        NSDictionary * properties = [NBSAppAgent performSelector:@selector(getSDKStartInfo)];
        result(properties);
    }else if([@"enterAction" isEqualToString:call.method]){
        NSString *name = [call.arguments valueForKey:@"name"];
        NSNumber *keyNum = [call.arguments valueForKey:@"key"];
        NSString *time = [call.arguments valueForKey:@"enterTime"];
        if (name && [keyNum isKindOfClass:[NSNumber class]]) {
            [NBSAppAgent enterAction:name withKey:keyNum withTime:time];
        }
        
    }else if([@"leaveAction" isEqualToString:call.method]){
        
        NSNumber *keyNum = [call.arguments valueForKey:@"key"];
        NSString *time = [call.arguments valueForKey:@"leaveTime"];
        if ([keyNum isKindOfClass:[NSNumber class]]) {
            [NBSAppAgent leaveAction:keyNum withTime:time];
        }

    } else if([@"setUserIdentifier" isEqualToString:call.method]){
        NSString *userId = [call.arguments valueForKey:@"user"];
        if (userId && [userId isKindOfClass:[NSString class]]) {
            [NBSAppAgent setUserIdentifier:userId];
        }

    }else if ([@"reportError" isEqualToString:call.method]){
        NSString *message = [call.arguments valueForKey:@"reason"];
        NSString *stacktrace = [call.arguments valueForKey:@"stacktrace"];
        NSDictionary *metaData = [call.arguments valueForKey:@"props"];
        if (stacktrace) {
            NSDictionary *dict = @{@"stack":stacktrace,@"lt":@"flutter"};
            [NBSAppAgent reportError:message withException:(NSException *)dict withMetaData:metaData];
        }

    }else if([@"leaveBreadcrumb" isEqualToString:call.method]){
        NSString *breadCrumb = [call.arguments valueForKey:@"breadCrumb"];
        if (breadCrumb && [breadCrumb isKindOfClass:[NSString class]]) {
            [NBSAppAgent leaveBreadcrumb:breadCrumb];
        }
    }else if([@"setUserCrashMessage" isEqualToString:call.method]){
        NSString *key = [call.arguments valueForKey:@"key"];
        NSString *value = [call.arguments valueForKey:@"value"];
        [NBSAppAgent setCustomerData:value forKey:key];
    }else if([@"onEvent" isEqualToString:call.method]){
        NSString *eventId = [call.arguments valueForKey:@"eventId"];
        NSString *tag = [call.arguments valueForKey:@"tag"];
        NSDictionary *props = [call.arguments valueForKey:@"props"];
        [NBSAppAgent trackEvent:eventId withEventTag:tag withEventProperties:props];
    }else if ([@"getRequestTagForInterceptor" isEqualToString:call.method]){
        NSString *uuid = [[NSUUID UUID] UUIDString];
        NSString *tingyunId = [NBSAppAgent performSelector:@selector(getTingyunId)];

        NSDictionary* dict =@{@"crossHeader":(tingyunId ? tingyunId : @""),@"uuid":uuid};
        if (result) {
            result(dict);
        }
    }else if([@"startWebRequestTiming" isEqualToString:call.method]){
        [NBSAppAgent performSelector:@selector(flutterNetworkStart:) withObject:call.arguments];
    }else if ([@"stopWebRequestTiming" isEqualToString:call.method]){
        [NBSAppAgent performSelector:@selector(flutterNetworkFinish:) withObject:call.arguments];
    }else if([@"getRequestTag" isEqualToString:call.method]){
        NSString *uuid = [[NSUUID UUID] UUIDString];
        if (result) {
            result(uuid);
        }
    }else if([@"setCustomOnResumeEndIns" isEqualToString:call.method]){
        NSString *string = [call.arguments valueForKey:@"className"];
        [NBSAppAgent lanuchFinish:string];
    }
    else{
        result(FlutterMethodNotImplemented);
    }
}

@end
