/// The Web request timing interface which can be used to measure a web request manually
abstract class TYWebRequestTiming{
  /// Start the measurment of the web request. Call this before the request is started.
  void start();

  // Stops the measurment of the web request. This needs to be called after the request is executed.
  /// The [responseCode] and [responseMessage] will be transfered and shown in the web UI.
  // void stopWebRequestTiming(int responseCode, String responseMessage);
  void stop(int responseCode);

  /// Returns the content for the header that is needed in order to track a request
  String getRequestTag();

  /// Returns the name for the header that is needed in order to track a request
  String getRequestTagHeader();

  /// set the dns info
  void withDnsInfo(int dnsTime, String ipInfo);
}