import 'dart:collection';

import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:tingyun_flutter_plugin/src/agent/agent_impl.dart';


void main() {
  const MethodChannel channel = MethodChannel(TingyunFlutterImpl.methodChannelName);

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      if(methodCall.method == 'getAutoStartConfiguration'){
        print('getAutoStartConfiguration test happened');
        var result = Map();
        result["key"] = false;
        return result;
      }
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  ///测试接口相关的内容
  test('getAutoStratConfiguration', () async {
    TingyunFlutterImpl impl = TingyunFlutterImpl();
    Map<String, bool>? result = await impl.getAutoStratConfiguration();
    expect(result, {'key': false});
  });

  ///测试start相关的内容逻辑
  test('testStart', () async{
    // TingyunFlutterImpl? impl = TingyunFlutterImpl();
    // impl.start();
  });
}
